Reconstruction Benchmarks for the EIC
=====================================

[![pipeline status](https://eicweb.phy.anl.gov/EIC/benchmarks/reconstruction_benchmarks/badges/master/pipeline.svg)](https://eicweb.phy.anl.gov/EIC/benchmarks/reconstruction_benchmarks/-/commits/master)


## Running Locally

### Local development example

Here we setup to use our local build of the `juggler` library.
First set some environment variables.
```
export JUGGLER_INSTALL_PREFIX=/usr/local
export DETECTOR=epic             # epic is the default
export BEAMLINE_CONFIG=ip6       # ip6 is the default
```



```
git clone https://eicweb.phy.anl.gov/EIC/benchmarks/reconstruction_benchmarks.git && cd reconstruction_benchmarks
git clone https://eicweb.phy.anl.gov/EIC/benchmarks/common_bench.git setup
source setup/bin/env.sh && ./setup/bin/install_common.sh
source .local/bin/env.sh && build_detector.sh
mkdir_local_data_link sim_output
mkdir -p results config
```




## Benchmarks

### Clustering

Located in `clustering` directory.
- Barrel Clusters (`clustering/barrel_clusters.sh`)

### EM Calorimetry

Located in `clustering` directory.
- Crystal Calorimeter electron reconstruction (`ecal/emcal_electrons.sh`)
- Crystal Calorimeter pi0 reconstruction (`ecal/emcal_pi0s.sh`)

Todo:
- ECal endcaps/barrel calorimetry
- Crystal calorimeter/endcap/barrel energy reconstruction efficiency 

### Tracking

Located in `tracking` directory.
- Central (barrel) electron track reconstruction (`tracking/central_electrons.sh`)

Todo: 
- Endcap electron tracks.
- TOF PID with UFSD

### RICH

Located in `rich` directory.
- PID of forward hadrons -- kaons/pions/protons (`rich/forward_hadrons.sh`)

Todo:
- detailed K/pi separation
 
 
## Adding new benchmarks

### Pass/Fail tests

- Create a script that returns exit status 0 for success.
- Any non-zero value will be considered failure.
- Script  


### Junit reports via gitlab API

Example:

```
curl "https://eicweb.phy.anl.gov/api/v4/projects/18/pipelines/4832/test_report"
```


