#include "ROOT/RDataFrame.hxx"
#include "TCanvas.h"
#include "TLegend.h"
#include "TH1D.h"
#include "TProfile.h"

#include <iostream>

R__LOAD_LIBRARY(libedm4eic.so)
#include "edm4hep/MCParticleCollection.h"
#include "edm4eic/TrackParametersCollection.h"
#include "edm4eic/ClusterCollection.h"
#include "edm4eic/ClusterData.h"
#include "edm4eic/TrackerHitCollection.h"

using ROOT::RDataFrame;
using namespace ROOT::VecOps;

int print_far_forward_protons(const char* fname = "topside/rec_far_forward_protons.root")
{
  ROOT::RDataFrame df("events", fname);

  auto df0 = df.Range(10);

  auto d1 = df0.Display(
      {
        "ForwardRomanPotParticles.momentum.x",
        "ForwardRomanPotParticles.momentum.y",
        "ForwardRomanPotParticles.momentum.z"
      }
    );
  auto d2 = df0.Display(
      {
        "ForwardOffMTrackerParticles.momentum.x",
        "ForwardOffMTrackerParticles.momentum.y",
        "ForwardOffMTrackerParticles.momentum.z"
      }
    );

  d1->Print();
  d2->Print();

  return 0;
}
